clear

global override override_param_names

setpathdynare4;

%% Run model

override_param_names = 'gammap'; 
override = 0.5;

dynare rbcb_2sector_monetary noclearall      
lgx_ = M_.exo_names;
lgy_ = M_.endo_names;
dr_ = oo_.dr;
ys_ = oo_.dr.ys;

save simulation1 dr_ ys_ lgy_ lgx_



% % invoke dynare with noclearall option if any parameter is over-ridden
% dynare rbcb_monetary noclearall     
% 
% lgx_ = M_.exo_names;
% lgy_ = M_.endo_names;
% dr_ = oo_.dr;
% ys_ = oo_.dr.ys;
% 
% save simulation2 dr_ ys_ lgy_ lgx_

%% simulation horizon
nperiods = 40;

load simulation1

shock =  [ 0    %erra      technology
           0.026340388032298 %errbt     transfer from banks to households  
           0
           0
           0]'; %consumption preference shock 
dset = 'f1';        
makeirf



% load simulation2
% % erra, errmon, errlambda, errbt, errbetavar, errcpref
% shock =  [ 0    %erra      technology
%            0
%            0
%            0.069147593709615  % transfer
%            0
%            0]'; % consumption
% dset = 'f2';        
% makeirf


titlelist = char('Cumulative transfer (gdp share, ar)', 'Output',...
                 'Investment', 'Consumption ',...
                 'Price of Capital','Bank Net Interest Margins (ar)',...
                 'Deposit Rate (ar)','Bank Equity');
figlabel = '';

legendlist = char('');

pc = 'Percent Dev. from SS';
ppt = 'PPt. Dev. from SS';

ylabels = char(ppt, pc,...
               pc, pc,...
               ppt, ppt,...
               ppt, pc);

line1 = 100*[cumsum(f1_bt_irf)/f1_y/4 f1_y_irf/f1_y ...
              f1_in_irf/f1_in f1_c_irf/f1_c ...
              f1_q_irf/f1_q f1_spreadb_irf*4 ...
              f1_r_irf*4 f1_n_irf/f1_n];
          
% line2 = 100*[cumsum(f2_bt_irf)/f2_y/4 f2_y_irf/f2_y ...
%               f2_in_irf/f2_in f2_c_irf/f2_c ...
%               f2_q_irf/f2_q f2_spread_irf*4 ...
%               f2_r_irf*4 f2_n_irf/f2_n];
         

makechart(titlelist,legendlist,figlabel,ylabels,line1)


titlelist= char('Price of Capital','Loan Rate (ar)', ...
                'Loans','Hours worked',...
                'Wages','Loans to Equity');
figlabel = '';
ylabels = char(pc, ppt,...
               pc,pc,...
               pc, ppt);
line1 = 100*[f1_q_irf, f1_rb_irf*4 ...
              f1_sb_irf/f1_sb f1_l_irf/f1_l ...
              f1_w_irf/f1_w f1_l2n_irf];
          

% line2 = 100*[f2_q_irf, f2_rs_irf*4 ...
%               f2_s_irf/f2_s f2_l_irf/f2_l ...
%               f2_w_irf/f2_w f2_l2n_irf];
        
          
makechart(titlelist,legendlist,figlabel,ylabels,line1)

