clear all

global override override_param_names

setpathdynare4;

%% Run model


dynare rbcb_2sector_monetary noclearall      
lgx_ = M_.exo_names;
lgy_ = M_.endo_names;
dr_ = oo_.dr;
ys_ = oo_.dr.ys;

save simulation1 dr_ ys_ lgy_ lgx_ M_



% invoke dynare with noclearall option if any parameter is over-ridden
dynare rbcb_monetary noclearall     

lgx_ = M_.exo_names;
lgy_ = M_.endo_names;
dr_ = oo_.dr;
ys_ = oo_.dr.ys;

save simulation2 dr_ ys_ lgy_ lgx_ M_

override_param_names = 'alphafp'; 
override = 0.75;
dynare rbcb_2sector_monetary noclearall      
lgx_ = M_.exo_names;
lgy_ = M_.endo_names;
dr_ = oo_.dr;
ys_ = oo_.dr.ys;

save simulation3 dr_ ys_ lgy_ lgx_ M_


%% simulation horizon
nperiods = 43;

load simulation1

shock =  [ 0    %erra      technology
           0.026340388032298 %errbt     transfer from banks to households  
           0
           0
           0]'; %consumption preference shock 
dset = 'f1';        
makeirf



load simulation2
% erra, errmon, errlambda, errbt, errbetavar, errcpref
shock =  [ 0    %erra      technology
           0
           0
           0.069147593709615  % transfer
           0
           0]'; % consumption
dset = 'f2';        
makeirf

load simulation3
shock =  [ 0    %erra      technology
           0.026340388032298*1.191279140564568 %errbt     transfer from banks to households  
           0
           0
           0]'; %consumption preference shock 
dset = 'f3';        
makeirf



%%
titlelist = char('Cumulative transfer (gdp share, ar)', 'Output',...
                 'Investment', 'Consumption ',...
                 'Price of Capital','Bank Spread (1 year)',...
                 'Deposit Rate (1 year)','Bank Equity');
figlabel = '';

legendlist = char('Benchmark','All Credit','Expanded Equity Sector');

pc = 'Percent Dev. from SS';
ppt = 'PPt. Dev. from SS';

ylabels = char(ppt, pc,...
               pc, pc,...
               ppt, ppt,...
               ppt, pc);

nobs=length(f1_spreadb_irf); 
f1_spreadb_year_irf = nan*f1_spreadb_irf;
f2_spread_year_irf = nan*f1_spreadb_irf;
f3_spreadb_year_irf = nan*f1_spreadb_irf;

f1_r_year_irf=nan*f1_spreadb_irf;
f2_r_year_irf=nan*f1_spreadb_irf;
f3_r_year_irf=nan*f1_spreadb_irf;

for i = 1:nobs-3
    f1_spreadb_year_irf(i) = sum(f1_spreadb_irf(i:i+3));
    f2_spread_year_irf(i) = sum(f2_spread_irf(i:i+3));
    f3_spreadb_year_irf(i) = sum(f3_spreadb_irf(i:i+3));
   
    f1_r_year_irf(i) = sum(f1_r_irf(i:i+3));
    f2_r_year_irf(i) = sum(f2_r_irf(i:i+3));
    f3_r_year_irf(i) = sum(f3_r_irf(i:i+3));
    
end
          
           
line1 = 100*[cumsum(f1_bt_irf)/f1_y/4 f1_y_irf/f1_y ...
              f1_in_irf/f1_in f1_c_irf/f1_c ...
              f1_q_irf/f1_q f1_spreadb_year_irf ...
              f1_r_year_irf f1_n_irf/f1_n];
          
line2 = 100*[cumsum(f2_bt_irf)/f2_y/4 f2_y_irf/f2_y ...
              f2_in_irf/f2_in f2_c_irf/f2_c ...
              f2_q_irf/f2_q f2_spread_year_irf ...
              f2_r_year_irf f2_n_irf/f2_n];
         
line3 = 100*[cumsum(f3_bt_irf)/f3_y/4 f3_y_irf/f3_y ...
              f3_in_irf/f3_in f3_c_irf/f3_c ...
              f3_q_irf/f3_q f3_spreadb_year_irf ...
              f3_r_year_irf f3_n_irf/f3_n];
makechart(titlelist,legendlist,figlabel,ylabels,line1(1:40,:),line2(1:40,:),line3(1:40,:))


%titlelist= char('Price of Capital','Loan Rate (ar)', ...
%                'Loans','Hours worked',...
%                'Wages','Loans to Equity');
% figlabel = '';
% ylabels = char(pc, ppt,...
%                pc,pc,...
%                pc, ppt);
% line1 = 100*[f1_q_irf, f1_rb_irf*4 ...
%               f1_sb_irf/f1_sb f1_l_irf/f1_l ...
%               f1_w_irf/f1_w f1_l2n_irf];
%           
% 
% line2 = 100*[f2_q_irf, f2_rs_irf*4 ...
%               f2_s_irf/f2_s f2_l_irf/f2_l ...
%               f2_w_irf/f2_w f2_l2n_irf];
%         
%           
% makechart(titlelist,legendlist,figlabel,ylabels,line1, line2)

