var k, y, w, rs, lambdac, l, r, s, n, v, eta, in, ig, q, c, gc, a, spread, 
    l2n, rmon, infl, phi, dphidp, dphidlp, sigma, lambda, bt, n2y, betavar, 
    cpref, rpot; 

// REMEMBER TO revert interest rate timing to previous version 
// 
      
// innovations to shock processes
varexo erra, errmon, errlambda, errbt, errbetavar, errcpref;


parameters alphap, gammap, chip, betap, deltap,
           phip, epsilonp, rhoa, shareg,
           lambdap, thetap, omegap, s2n, blife, phi_p, spreadp,
           rs_rsl_p, rs_infl_p, rs_y_p, xi_p, tau_p, kappa_p, theta_p,indexp,
           rho_lambdap, rho_btp, rho_betavarp, rho_cprefp,
           lss, qss, rss, yss, wss, kss, sss, nss, 
           inss, igss, gcss, infl_ss;



model;
/////////////////////////////////////////////////////////////////

// 1. k, capital (next period)
k = s;

// 2. y, output
y=exp(a)*k(-1)^alphap*l^(1-alphap);

// 3. w, wages
l=(1-alphap)*sigma*y/w;

// 4. rs, return on stocks in consumption units
1+rs = alphap*sigma*y/(q(-1)*k(-1))+(1-deltap)*q/q(-1);

// 5. lambdac, marginal utility of consumption
lambdac=1/(c-gammap*c(-1)+cpref)-betavar*gammap/(c(1)-gammap*c+cpref(1));

// 6. l, hours worked
lambdac*w = chip*l^epsilonp;

// 7. r, risk-free interest rate
lambdac(1)/lambdac = 1/(betavar*(1+r));

// This is the financial accelerator block of the code:
// 8. s,  stocks, from incentive compatibility constraint
q*s = eta/(lambda-v)*n*(1-bt);

// 9. n, banks' equity, from law of motion for equity
n= thetap *((rs-r(-1))*eta(-1)/(lambda(-1)-v(-1))+1+r(-1))*n(-1)*(1-bt(-1)) + omegap*q*s(-1);

// 10. v, marginal gain from an extra unit of sq, keeping n constant
v = (1-thetap)*betap*lambdac(1)/lambdac*(rs(1)-r)+thetap*betap*lambdac(1)/lambdac*( (eta(1)/(lambdap-v(1))) / (eta/(lambdap-v))*((rs(1)-r)*eta/(lambdap-v)+1+r))*(1-bt(1))*v(1);

// 11. eta, marginal gain from an extra unit of n, keeping sq constant
eta = (1-thetap)+thetap*betap*lambdac(1)/lambdac*((rs(1)-r)*eta/(lambdap-v)+1+r)*(1-bt(1))*eta(1);

// 12. in, investment net of adjustment costs
k = in+(1-deltap)*k(-1);

// 13. ig, gross investment
in = (1-phip/2*(ig/ig(-1)-1)^2)*ig;

// 14. q, price of capital
1 = q*(1-phip/2*(ig/ig(-1)-1)^2)-q*phip*(ig/ig(-1)-1)*ig/ig(-1)+lambdac(1)/lambdac*q(1)*phip*(ig(1)/ig-1)*ig(1)^2/ig^2;

// 15. c, consumption
y = c+ig+gc;

// 16. gc, government spending
gc = shareg*y;

// 17. a, technology
a = rhoa*a(-1)+erra;

// 18. Spread
spread = rs(1) - r;

// 19. Ratio of loans to equity (pre-bt shock)
l2n = eta/(lambdap-v);

0 = (-(1+tau_p)/theta_p + sigma*(1 + theta_p)/theta_p)*(1-phi)*y
    - ((1 + tau_p) - sigma)*y*dphidp
    - (1/(1+r))*((1+tau_p) - sigma(1))*y(1)*dphidlp(1);

//price adjustment costs
phi = (phi_p/2)*(infl/(indexp*infl(-1)+(1-indexp)*infl_ss) - 1)^2;
dphidp = phi_p*(infl/(indexp*infl(-1)+(1-indexp)*infl_ss) - 1)*infl/(indexp*infl(-1)+(1-indexp)*infl_ss);
dphidlp = -phi_p*(infl/(indexp*infl(-1)+(1-indexp)*infl_ss) - 1)*infl^2/(indexp*infl(-1)+(1-indexp)*infl_ss);

// Interest rate reaction function
rmon = 0;
rpot = rss 
	      +  rs_rsl_p *(rpot(-1) - (- 1 + 1/betap ) ) 
	      +  (1-rs_rsl_p)*rs_infl_p * (infl - infl_ss)
	      +  (1-rs_rsl_p)*rs_y_p * (log(y)- log(y(-1)))+errmon;


r = rmon/infl(1);


// shock process for lambda 
lambda - lambdap = rho_lambdap * (lambda(-1) - lambdap) + errlambda;

// shock process for transfer
bt = rho_btp*bt(-1) + errbt;

// shock to beta
betavar - betap = rho_betavarp*(betavar(-1)-betap)+errbetavar;

// consumption preference shock
cpref = rho_cprefp * cpref(-1) + errcpref;
n2y = n/y;


end;




